/*
 * This is the hostname->IP converter..  
 */

#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netinet/tcp.h>
#include <string.h>
#include <stdio.h>

int resolve_host(host)
char *host;
{
  struct hostent *hp;
  struct sockaddr_in sin;
  u_long addr;

  sin.sin_family = AF_INET;
  if((sin.sin_addr.s_addr = inet_addr(host)) == -1) {
    if((hp = gethostbyname(host)) != NULL) {
      sin.sin_family = hp->h_addrtype;
      bcopy(hp->h_addr,(caddr_t)&sin.sin_addr,hp->h_length);
      
      addr=inet_netof(sin.sin_addr);
      if(addr >(u_long) 0xFFFFFF && addr <=(u_long) 0xFFFFFFFF)
	; /* no operation */
      else if(addr >(u_long) 0xFFFF && addr <=(u_long) 0xFFFFFF)
	addr=(addr<<8)+inet_lnaof(sin.sin_addr);
      else if(addr >(u_long) 0xFF && addr <=(u_long) 0xFFFF)
	addr=(addr<<16)+inet_lnaof(sin.sin_addr);
      else addr=(addr<<24)+inet_lnaof(sin.sin_addr);
      return(addr);
    } else {
      fprintf(stderr,"error: unknown host %s\n",host);
      exit(1);
    }
  }
  addr=inet_netof(sin.sin_addr);
  if(addr >(u_long) 0xFFFFFF && addr <=(u_long) 0xFFFFFFFF)
    ; /* no operation */
  else if(addr >(u_long) 0xFFFF && addr <=(u_long) 0xFFFFFF)
    addr=(addr<<8)+inet_lnaof(sin.sin_addr);
  else if(addr >(u_long) 0xFF && addr <=(u_long) 0xFFFF)
    addr=(addr<<16)+inet_lnaof(sin.sin_addr);
  else addr=(addr<<24)+inet_lnaof(sin.sin_addr);
  return(addr);
}
