/*
 * This program will generate almost any type of ICMP packet, and spoof
 * the IP address to match the real sender..
 */

extern  char  *optarg;
extern  int   optind;


void main(argc,argv)
int argc;
char **argv;
{
  int i, type=1,loops=1,packet=8,len=64;
  char *packetn="ECHO",*typen="NONE";

  printf("                        .o0 Universal ICMP Generator 0o.\n");

  while((i=getopt(argc,argv,"hp:l:t:d:")) != -1) {
    switch(i) {
    case 'd':
      len=atoi(optarg);
      break;
    case 'h':
      help(argv[0]);
      break;
    case 'p':
      if((packet=resolve_packet(optarg))<0) help(argv[0]);
      packetn=(char *)optarg;
      break;
    case 'l':
      loops=atoi(optarg);
      break;
    case 't':
      if((type=resolve_type(optarg,packet))<0) help(argv[0]);
      typen=(char *)optarg;
      break;
    }
  }
  if(optind+2 != argc) usage(argv[0]);

  /* Error checking */
  if(packet!=3 && packet!=5 && packet!=11) type=0;
  else if(strncmp(typen,"NONE",4)==0) usage(argv[0]);

  printf("Sending:\n");
  printf("PACKET %s\n",packetn);
  printf("TYPE   %s\n",typen);
  printf("LOOPS  %d\n",loops);
  printf("TO     %s\n",argv[optind]);
  printf("FROM   %s\n",argv[optind+1]);
  printf("DATA   %d\n",len);
  do_packet(argv[optind],argv[optind+1],packet,type,loops,len);
}
